import os
import execute

histories = {}

class InputStringExecContext(execute.ExecutionContext):
	pass

def input_string(cmd, prompt='', historykey=None, completor=None, initial=''):
	if (historykey == None):
		history = None
	else:
		history = histories.get(historykey)
		if (history == None):
			history = []
			histories[historykey] = history

	exex = InputStringExecContext(cmd.executor)
	
	minibuf.activate(prompt+': ', history, completor, initial)
	exex.savedfocus = window.focuswin
	window.changefocus(-1)

	try:
		while 1:
			try:
				screen.inputloop(exex)
			except command.DoneException:
				res = minibuf.buf.body
				if (history != None and res != ''):
					if (len(history) == 0 or history[-1] != res):
						history.append(res)
						### trim down to last 100?
				return res
	finally:
		minibuf.deactivate()
		window.changefocus(exex.savedfocus)
		buf = buffer.findbyname('*completions*')
		if (buf):
			buf.ensureclosed()
		status.post('')

def input_string_arg(cmd, argnum=1, prompt='', historykey=None, completor=None, initial=''):
	if (argnum <= cmd.countargs()):
		return cmd.getarg(argnum)
	return input_string(cmd, prompt, historykey, completor, initial)
		
def input_filename(cmd, prompt='', historykey=None, initial=None):
	home = os.path.expanduser('~')
	if (initial == None):
		initial = os.getcwd() + os.sep
	if (initial.startswith(home)):
		initial = '~' + initial[len(home) : ]
	complet = completion.FilenameCompletor()
	st = input_string(cmd, prompt, historykey, complet, initial)
	if (st.startswith(home)):
		st = '~' + st[len(home) : ]
	return st

def input_filename_arg(cmd, argnum=1, prompt='', historykey=None, initial=None):
	if (argnum <= cmd.countargs()):
		return cmd.getarg(argnum)
	return input_filename(cmd, prompt, historykey, initial)

# late imports
import buffer
import minibuf
import status
import window
import command
import completion
import screen
